/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: volume.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#include <polymake.h>
#include <Integer.h>
#include <Array.h>
#include <Matrix.h>
#include <linalg.h>

namespace polymake { namespace polytope {

   template <typename Scalar, typename Triangulation>
   Scalar volume(const Matrix<Scalar>& Points, const Triangulation& tr)
   {
      Scalar V(0);
      const int dim=tr.front().size()-1;
      for (typename Entire<Triangulation>::const_iterator s=entire(tr); !s.at_end(); ++s)
	 V += abs(det( Points.minor(*s,All) ));
      return V / Integer::fac(dim);
   }

   FunctionTemplate4perl("volume(Matrix *)");
} }
